VERSION 5.00
Begin VB.Form frmChangeBorderStyle 
   AutoRedraw      =   -1  'True
   Caption         =   "Change BorderStyle At RunTime"
   ClientHeight    =   2940
   ClientLeft      =   1860
   ClientTop       =   1500
   ClientWidth     =   4965
   LinkTopic       =   "Form1"
   OLEDropMode     =   1  'Manual
   ScaleHeight     =   196
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   331
   Begin VB.CommandButton Command1 
      Caption         =   "Make My Border Fixed"
      Height          =   495
      Left            =   1065
      TabIndex        =   0
      Top             =   990
      Width           =   2835
   End
End
Attribute VB_Name = "frmChangeBorderStyle"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
  Option Explicit
  ' demo project showing how to manipulate the style bits of a VB
  ' form via the SetWindowLong and GetWindowLong API functions
  ' by Bryan Stafford of New Vision Software - newvision@imt.net
  ' this demo is released into the public domain "as is" without
  ' warranty or guaranty of any kind.  In other words, use at
  ' your own risk.
  
  Private Const GWL_STYLE As Long = (-16&)
  Private Const GWL_EXSTYLE As Long = (-20&)
  Private Const WS_THICKFRAME As Long = &H40000
  Private Const WS_MINIMIZEBOX As Long = &H20000
  Private Const WS_MAXIMIZEBOX As Long = &H10000
  
  Private Declare Function GetWindowLong& Lib "user32" _
      Alias "GetWindowLongA" (ByVal hWnd&, ByVal nIndex&)
  Private Declare Function SetWindowLong& Lib "user32" _
      Alias "SetWindowLongA" (ByVal hWnd&, ByVal nIndex&, _
      ByVal dwNewLong&)
      
  Private Type POINTAPI
    x As Long
    y As Long
  End Type
      
  Private Declare Function GetCursorPos& Lib "user32" (lpPoint As POINTAPI)
  Private Declare Function SetCursorPos& Lib "user32" (ByVal x&, ByVal y&)

  Private Declare Function ClientToScreen& Lib "user32" (ByVal hWnd&, lpPoint As POINTAPI)
  
  Private Declare Function GetSystemMenu& Lib "user32" (ByVal hWnd&, ByVal bRevert&)

Private Sub Command1_Click()
  
  ' we start off sizeable and change the style bits for the form to Fixed on the first
  ' click of the button.  Each subsequent click just reverses the last action
  Call SetWindowLong(hWnd, GWL_STYLE, GetWindowLong(hWnd, GWL_STYLE) Xor _
                              (WS_THICKFRAME Or WS_MINIMIZEBOX Or WS_MAXIMIZEBOX))

  ' cause the system menu to revert to the state
  ' that is appropriate for the current borderstyle
  Call GetSystemMenu(hWnd, 1&)

  ' change the button caption to the appropriate string
  Select Case Command1.Caption
    Case "Make My Border Fixed"
      Command1.Caption = "Make My Border Sizeable"
      
    Case Else
      Command1.Caption = "Make My Border Fixed"
            
  End Select
  
  ' adjust the size of the form to force the window to redraw correctly
  Move Left, Top, Width - 50, Height - 50
  Move Left, Top, Width + 50, Height + 50
        
  Dim tagSavePoint As POINTAPI, tagMovePoint As POINTAPI
  
  ' we need to move the cursor over the border of the form to get the nonclient area to
  ' redraw.  We just move it there and then back to the original position.
  Call GetCursorPos(tagSavePoint)
        
  With tagMovePoint
    .x = (-1)
    .y = 10
  End With
  
  Call ClientToScreen(hWnd, tagMovePoint)
  
  Call SetCursorPos(tagMovePoint.x, tagMovePoint.y)
  
  Call SetCursorPos(tagSavePoint.x, tagSavePoint.y)
    
End Sub
